<?php
/*
Plugin Name: Post Thumbnail Widget
Plugin URI: http://iworks.pl/wordpress-plugins-post-thumbnail-widget/
Description: Allow to publish post thumbnails on sidebar.
Version: 1.0.1
Author: Marcin Pietrzak
Author URI: http://iworks.pl/
Donate link: https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=marcin%40iworks%2epl&item_name=Post%20Thumbnail%20Widget&no_shipping=0&no_note=1&tax=0&currency_code=PLN&lc=PL&bn=PP%2dDonationsBF&charset=UTF%2d8

* $Id: post-thumbnail-widget.php 238530 2010-05-08 00:55:45Z iworks $
* $HeadURL: http://plugins.svn.wordpress.org/post-thumbnail-widget/tags/1.0.1/post-thumbnail-widget.php $
 */

//load_plugin_textdomain( PostThumbnailWidget::$id, PLUGINDIR.'/'.dirname( plugin_basename( __FILE__ ) ), dirname( plugin_basename( __FILE__ ) ).'/lang',dirname( plugin_basename( __FILE__ ) ).'/lang' );

class PostThumbnailWidget
{
    public static $id = 'post-thumbnail-widget';

    public function init()
    {
        wp_register_sidebar_widget( self::$id, __( 'Post Thumbnail Widget', self::$id ), array( 'PostThumbnailWidget', 'sidebar'), array( 'description'=>__( 'Allow to publish post thumbnails on sidebar.' ), 'class'=>self::$id ) );
        wp_register_widget_control( self::$id, __( 'Post Thumbnail Widget', self::$id ), array( 'PostThumbnailWidget', 'options' ) );
    }

    #
    # update_options()
    #

    public function update_options()
    {
        if ( function_exists( 'update_site_option' ) && ( function_exists( 'is_site_admin' ) && is_site_admin() ) )
        {
            update_site_option( self::$id, $_POST[ self::$id ] );
        }
        else
        {
            update_option( self::$id, $_POST[ self::$id ] );
        }
    } # update_options()

    #
    # show()
    #

    public function show()
    {
        $options = get_option( self::$id );
        query_posts( 'meta_key=_thumbnail_id&orderby=rand' );
        $limit = 1;

        if ( isset ( $options['limit'] ) and preg_match( '/^\d+$/', $options['limit'] ) )
        {
            $limit = $options['limit'];
        }

        global $more;
        $more = 0;
        print '<ol>';
        while ( have_posts() and $limit)
        {
            the_post();
            printf (
                '<li><a href="%s" title="%s">%s</a></li>',
                get_permalink(),
                get_the_title(),
                get_the_post_thumbnail( get_the_ID() )
            );
            $limit--;
        }
        print '</ol>';
        wp_reset_query();
    } # show()

    #
    # sidebar()
    #

    public function sidebar( $args ) {
        extract( $args );
        $options = get_option( self::$id );
        echo $before_widget;
        if ( isset( $options['title'] ) && $options['title'] ) {
            print( $before_title . $options['title'] . $after_title );
        }
        self::show();
        echo $after_widget;
    } #sidebar()

    #
    # options()
    #
    public function options()
    {
        if ( $_POST[self::$id] )
        {
            self::update_options();
        }
        $options = get_option( self::$id );
        /* begin options */
        echo '<div class="widget-content">';
        /* title */
        echo '<p><label for="'.self::$id.'-title">' . __( 'Title:' ) .'</label>';
        echo '<input type="text" value="'.$options['title'].'" name="'.self::$id.'[title]" id="'.self::$id.'-title" class="widefat"></p>';
        /* number */
        echo '<p><label for="'.self::$id.'-limit">' . __( 'How many items would you like to display?') .'</label> ';
        echo '<input type="text" value="'.$options['limit'].'" name="'.self::$id.'[limit]" id="'.self::$id.'-limit" size="3"></p>';
        /* end options */
        echo '</div>';
    } # options()

}
add_action( 'plugins_loaded', array( 'PostThumbnailWidget', 'init' ) );

?>
